<?php
/*
Plugin Name: Wordpress Actualiza&ccedil;&atilde;o Autom&aacute;tica PT
Plugin URI: http://antoniocampos.no-ip.com
Description: Wordpress Actaliza&ccedil;&atilde;o Autom&aacute;tica permite actualizar de forma autom&aacute;tica a sua instala&ccedil;&atilde;o de Wordpress vers&atilde;o Portuguesa.
Use o link <a href="edit.php?page=wordpress-automatic-upgrade-pt/wordpress-automatic-upgrade.php">Wordpress Actualiza&ccedil;&atilde;o Autom&aacute;tica</a> *ara actualizar a sua vers&atilde;o
Obrigado a  <a href="http://www.ronalfy.com">Ronald Huereca</a>  Por tornar este plugin autom&aacute;tico.
Version: 0.8 - PT
Author: Keith Dsouza
Author URI: http://techie-buzz.com/

Change Log
---------------

@version 0.4
1. Added a prelim check before starting the process to check whether or not we can write files to the server
2. Checks if previous version files were not cleared
3. If we cannot write the files to server asking user for ftp credentials so that we can make the permission changes
4. Fixed bug where task status was not reported on error thus showing a db error to the user
5. Fixed a bug where open_basedir restriction is on for a website hosted as virtual folder

@version 0.5

1. Fixed bugs where user had a www folder with full write permissions but the public_html folder was not writable.
2. Fixed issue where while writing there were ftp errors while creating backup directory but still plugin said all ready to go
3. Fixed issue where plugins were not activating even if one plugin threw an error.
4. Fixed other issues with html and reporting

@version 0.6
bug fixes for security

@version 0.7
fixes for blogs that have the wordpress setup in a different directory and run the blog on a different directory

@version 0.8
Fix for database table name changes in WordPress 2.3 this should only affect blogs that are running WordPress 2.3 while running the Automatic Upgrade.

@version 0.8 PT 
Translated to Portuguese by Antonio Campos

Copyright 2007  Keith Dsouza  (email : dsouza.keith at gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


@define('WPAU_PAGE', 'wordpress-automatic-upgrade-pt/wordpress-automatic-upgrade.php');
@define('WPAU_BACKUP_DIR', 'wpau-backup');
@define('WPAU_FILES_ZIP', 'wpau-files-bak');
@define('WPAU_DB_ZIP', 'wpau-db-backup');
@define('WPAU_LOG_FILE', 'wpau-log-data.txt');
@define('WPAU_PLUGIN_TABLE', 'wpau_active_plugins_info');
@define('WPAU_LOG_TABLE', 'wpau_upgrade_log');
@define('WPAU_PLUGIN', 'wordpress-automatic-upgrade-pt/wordpress-automatic-upgrade.php');

	session_start();
	$serverSoft = $_SERVER['SERVER_SOFTWARE'];
	$isNix = true;
	if(stristr($serverSoft, "win32") !== false) {
		$isNix = false;
	}

	if($isNix)
		@define('WPAU_FILEPATH', 'wp-content/plugins/wordpress-automatic-upgrade-pt');
	else
		@define('WPAU_FILEPATH', 'wp-content\plugins\wordpress-automatic-upgrade-pt');

	//the logger class
	require_once('wpau_helper.class.php');


	$wpauDirPath = get_bloginfo('wpurl') . WPAU_FILEPATH;
	$wpauFileDirPath = ABSPATH. WPAU_FILEPATH;
	$wpAbsPath = ABSPATH;
	$wpIncludeDirs = array('wp-admin', 'wp-includes');
	$wpAllowedExt = array('zip');
	$theFuncComplete = false;
	$wpauMessage = '';
	$isAutomated = false;

	$task_list = array(
		'files',
		'backupdbopt',
		'backupdb',
		'newversionoption',
		'getlatestfiles',
		'maintmode',
		'de-plugin',
		'upgrade',
		're-plugin',
	);


	$task_description = array(
		'Cria copia dos ficheiros da actual instala&ccedil;&atilde;o',
		'Mostra as op&ccedil;es para copiar a base de dados',
		'Copia o ficheiro de base de dados',
		'Mostra as op&ccedil;es de envio de ficheiros',
		'Download / Upload os ficheiros actualizados do wordpress',
		'Coloca o site em estado de manuten&ccedil;&atilde;o',
		'Desactiva todos os plugins',
		'Actualiza todos os ficheiros do WordpressUpgrades all the installation files',
		'Re-Activa todos os plugins que estavam activados antes'
	);

	$automated_task_list = array(
		'files',
		'backupdb',
		'getlatestfiles',
		'maintmode',
		'de-plugin',
		'upgrade',
		're-plugin'
	);

	$automated_task_description = array(
		'Copia todos os ficheiros da instala&ccedil;&atilde;o actual do Wordpress',
		'Copia a base de dados',
		'Download / Upload os ficheiros actualizados',
		'Coloca o site em estado de manuten&ccedil;&atilde;o',
		'Desactiva todos os plugins',
		'Actualiza ficheiros da instala&ccedil;&atilde;o actual',
		'Re-Activa todos os plugins que estavam activados antes',
		'Limpa todos os ficheiros usados na actualiza&ccedil;&atilde;o'
	);

	if( isset($_REQUEST['task']) ) {
		$task = $_REQUEST['task'];
	}



	if (isset($wpdb)) {
		wpau_init();
	}


	function wpau_manage_page() {
		//add_menu_page('Automatic Upgrade', 'Automatic Upgrade', 0, 'wordpress-automatic-upgrade-pt/wordpress-automatic-upgrade.php' , 'wp_automatic_upgrade');
		add_submenu_page('edit.php', 'Actualizar Automatico', 'Actualizar Automatico', 2, 'wordpress-automatic-upgrade-pt/wordpress-automatic-upgrade.php', 'wp_automatic_upgrade');
	}

	function wp_automatic_upgrade() {
		if( ! user_can_access_admin_page()) {
			return false;
		}

		if(isset($_REQUEST['_wpnonce']) ) {
			if(function_exists('check_admin_referer')) {
				check_admin_referer('wordpress_automatic_upgrade');
			}
		}

		global $task;
		switch($task) {
			case 'start':
				show_upgrade_start();
				break;
			case 'files':
				wpau_backup_files();
				break;
			case 'backupdbopt':
				wpau_backup_db_options();
				break;
			case 'backupdb':
				wpau_backup_db();
				break;
			case 'newversionoption':
				wpau_show_new_version_forms();
				break;
			case 'getlatestfiles':
				wpau_get_latest_version();
				break;
			case 'maintmode':
				wpau_site_down();
				break;
			case 'de-plugin':
				wpau_deactivate_plugins();
				break;
			case 'upgrade':
				wpau_upgrade_installation();
				break;
			case 'updatedb':
				wpau_update_database();
				break;
			case 're-plugin':
				wpau_reactivate_plugins();
				break;
			case 'cleanup':
				wpau_cleanup();
				break;
			case 'done':
				wpau_show_backup_log();
				break;
			case 'logs':
				wpau_show_log();
				break;
			case 'prelimopts':
				wpau_prelim_opts_and_sanatize();
				break;
			default:
				wpau_run_prelims();
				break;
		}
	}

	/** adds the initial task to the database **/
	function wpauPersistNoLog($isUpdate, $showOutput = false, $automated = false) {
		if(isset($_REQUEST['_wpnonce']) ) {
			if(function_exists('check_admin_referer')) {
				check_admin_referer('wordpress_automatic_upgrade');
			}
		}
		global $isAutomated;
		$isAutomated = $automated;
		wpauPersist($isUpdate, '', false, '', $showOutput);
	}

	/** logs the output for a current task **/
	function wpauPersist($isUpdate, $theLog = '', $funcComplete = false, $message = '', $showOutput = true) {
		global $task, $wpdb, $task_list, $automated_task_list, $task_description, $automated_task_description, $isAutomated, $theFuncComplete;
		$datetime = date('Y-m-d H:i:s');
		if($isAutomated) {
			$currentPos = $task - 1;
			$taskname = $automated_task_list[$currentPos];
			$currentTaskDescription = $automated_task_description[$currentPos];
		}
		else {
			$currentPos = array_search($task, $task_list);
			$currentTaskDescription = $task_description[$currentPos];
			$taskname = $task;
		}

		if(! $isUpdate) {
			checkEntryAndDelete($task);
			//ok this is the first time the task is called so run a insert on the db
			$wpdb->query('INSERT into '.WPAU_LOG_TABLE.' (task_name, task_status, task_description, task_log, start_date)
						values (\''.$taskname.'\', 0, \''.$currentTaskDescription.'\' , \'\', \''.$datetime.'\')');
			return;
		}
		else {
			if($theFuncComplete == true)
				$functionStatus = 1;
			else
				$functionStatus = 0;

			$wpdb->query('UPDATE '.WPAU_LOG_TABLE.' set task_status = '.$functionStatus.', task_log = \''.mysql_real_escape_string($theLog).'\', end_date = \''.$datetime.'\' where task_name = \''.mysql_real_escape_string($taskname).'\'');
			if($isAutomated) return $theFuncComplete;
			if($theFuncComplete) {
				getWpauNextPage($task, $message, $showOutput);
			}
			else {
				$link = 'edit.php?page='.WPAU_PAGE.'&task=logs';
				if(function_exists('wp_nonce_url') ) {
					 $link = wp_nonce_url($link, 'wordpress_automatic_upgrade');
				}
				echo 'N&atilde;o foi possivel actualizar o Wordpress , <a href="'.$link.'">clique aqui</a> para ver o log da instala&ccedil;&atilde;o.';
			}
		}
	}

	/** start html **/
	function wpauStartHtml() {
?>
		<div align="left" style="margin-left:30px;"><br /><br />
			<div>
				<strong style="font-size:20px;">Wordpress Actualiza&ccedil;&atilde;o Autom&aacute;tica PT</strong>
				<p>Actualiza a sua instala&ccedil;&atilde;o do WordPress</p>
				<p><strong><u>Output das Tarefas</u></strong></p>
<?php
	}

	/** end html **/
	function wpauEndHtml() {
?>
			</div>
		</div>
		<div style="clear:both"></div>
<?php
	}

	/** if we are re-running the task we need to clear up old logs **/
	function checkEntryAndDelete($task) {
		//sometimes we need to retry tasks so we do it here such that we do not have duplicate entry for same task
		global $wpdb;
		$logs = $wpdb->get_results('SELECT id  from '.WPAU_LOG_TABLE.' where task_name = \''.$task.'\'');
		if(count($logs) > 0) {
			$wpdb->query('DELETE from '.WPAU_LOG_TABLE.' where task_name = \''.$task.'\'');
		}
	}

	/** clears all the upgraded data from the tables **/
	function clearUpgradeData() {
		global $wpdb;
		wpau_init();
		$wpdb->query('truncate table '. WPAU_LOG_TABLE);
		$wpdb->query('truncate table '. WPAU_PLUGIN_TABLE);
	}

	/** builds the output and creates a link to the next task if any exists **/
	function getWpauNextPage($task, $message, $showOutput = true) {
		global $task_list, $task_description, $theFuncComplete;
		//ensure multiple checks so that if previous task is not complete we
		//do not do the next step as all are inter-dependent
		$currentPos = array_search($task, $task_list);

		$currentTaskDescription = $task_description[$currentPos];

		//check if we have more tasks
		if($currentPos + 1 < count($task_list)) {
			$nextTask = $task_list[$currentPos + 1];
			$nextTaskDescription = $task_description[$currentPos + 1];
		}
		else {
			$nextTask = 'done';
			$nextTaskDescription = 'Congratulations your wordpress upgrade is complete.';
		}
		$nextLink = 'edit.php?page='.WPAU_PAGE.'&task='.$nextTask;
		if(function_exists('wp_nonce_url') ) {
			 $nextLink = wp_nonce_url($nextLink, 'wordpress_automatic_upgrade');
		}
		if($currentPost > count($task_list) || $currentPos < 0 ) {
			$link = 'edit.php?page='.WPAU_PAGE;
			if(function_exists('wp_nonce_url') ) {
				 $link = wp_nonce_url($link, 'wordpress_automatic_upgrade');
			}
			$message .= 'Sorry you came across a weird task that was not to be there. Please <a href="'.$link.'">click here</a> to restart again once more';
			$theFuncComplete = false;
		}

		if($showOutput && $theFuncComplete) {
			wpauStartHtml();
			echo '<strong>'.$message.'</strong>';
			echo "<hr /><strong>TASK STATUS</strong><br /><hr />";
			echo '<strong>Concluida a tarefa que </strong>, '.$currentTaskDescription.'. <br /><br />
			<strong>Pr&oacute;xima Tarefa -></strong> '.$nextTaskDescription.'
			<br /><br />Por favor <a href="'.$nextLink.'">CLIQUE AQUI</a> para continuar.';
			wpauEndHtml();
		}
		else if (! $theFuncComplete) {
			wpauStartHtml();
			echo '<strong>Alguma coisa correu mal e n&atilde;o &eacute; possivel continuar com este processo</strong>';
			$link = 'edit.php?page='.WPAU_PAGE;
			if(function_exists('wp_nonce_url') ) {
				 $link = wp_nonce_url($link, 'wordpress_automatic_upgrade');
			}
			echo '<p>Por favor <a href="'.$link.'">clique aqui</a> para recome&ccedil;ar</p>';
			wpauEndHtml();
		}

	}

	function wpau_show_reactivate_plugins($automated = false) {
		echo 'Parab&eacute;ns!!! Todos os ficheiros foram actualizados para a ultima vers&atilde;o. Por favor <a href="'.get_bloginfo('siteurl').'/wp-admin/upgrade.php" target="_blank">CLIQUE AQUI PARA ACTUALIZAR A BASE DE DADOS</a> (abre numa nova janela) e volte a esta janela para reactivar os plugins<br>';
		$link = 'edit.php?page='.WPAU_PAGE.'&task=re-plugin';
		if(function_exists('wp_nonce_url') ) {
			 $link = wp_nonce_url($link, 'wordpress_automatic_upgrade');
		}
		echo '<strong><a href="'.$link.'">Por favor clique aqui para reactivar os plugins, s&oacute; ap&oacute;s a actualiza&ccedil;&atilde;o da base de dados</a></strong>';
	}

	/** runs thorough preliminary checks to see if we can run WPAU on the user's server **/
	function wpau_run_prelims() {
		global $wbAbsPath, $isNix, $wpdb;
		$count = $wpdb->get_results('SELECT count(*) as counter from '.WPAU_LOG_TABLE);
		if($counter > 0) {
			if($count->counter > 0)
				clearUpgradeData();
		}

		//clearUpgradeData();
		$extra = '';
		require_once('wpau_prelimcheck.class.php');
		wpauStartHtml();
		echo "<hr /><strong>TASK STATUS</strong><br />";
		echo "Os primeiros testes ao servidor deram os seguintes resultados<hr />";
		$canWPAURun = true;
		$ftpError = false;
		$allClear = true;
		$message = '';
		$severeError = '';
		$prelimCheck = new wpauPrelimHelper(ABSPATH, $isNix);

		if($prelimCheck->checkCleanUpRequired()) {
			echo 'parece que o processo de limpeza da ultima actualiza&ccedil;&atilde;o n&atilde;o foi concluido. Por favor <a href="edit.php?page='.WPAU_PAGE.'&task=cleanup&returnhome=1">clique aqui para limpar antes de continuar<br>';
			wpauEndHtml();
			unset($prelimCheck);
			return false;
		}

		if(! $prelimCheck->runFTPPrelimChecks()) {
			$message .= 'O servidor n&atilde;o consegue escrever no directorio do Wordpress<br />
			Para continuar tem que efectuar uma destas duas ac&ccedil;es<br />';
			$ftpError = true;
			$allClear = false;
		}
		else if(ini_get('safe_mode')) {
			//safe mode man cannot run
			$severeError =  'O servidor est&aacute; em Safe-Mode. fale com o seu adminsitrador de sistema para o desactivar';
			$canWPAURun = false;
		}
		else if (!function_exists('gzopen')) {
			//urgh no zip support can't run
			$severeError =  'Oops o seu servidor n&atilde;o suporta a fun&ccedil;es de ZIP necess&aacute;rias para a actualiza&ccedil;&atilde;o';
			$canWPAURun = false;
		}

		if(! $prelimCheck->canMakeBackupDir) {
			$extra = "mbd=true";
		}
		//site is running in safe mode so we cannot continue
		if(! $canWPAURun) {
			echo '<p style="color:red;font-weight:bold">'. $severeError.'</p>';
			echo '</p>';
			wpauEndHtml();
			unset($prelimCheck);
			return false;
		}

		/**
			ok seems the site is having the ftp issue, show up the form to the user
			this happens when the ftp user and web users are different on a shared
			server running multiple sites
		**/
		if( $ftpError) {
			echo '<p style="color:red;font-weight:bold">'. $message.'</p>';
?>
	<ol>
				<li>Forne&ccedil;a os seus dados de FTP</li>
			</ol>
			<p><strong>Nota:</strong> N&atilde;o s&atilde;o armazenados os daos que insere, s&oacute; s&atilde;o pedidos estes dados para ser possivel a actualiza&ccedil;&atilde;o dos ficheiros do Wordpress.</p>
		<p>Qual &eacute; a raiz do seu FTP.
		Se instalou o Wordpress em  <strong>public_html</strong> ent&atilde;o a raiz &eacute; <strong>/public_html</strong><br />
		Se o Wordpress est&aacute; instalado em <strong>public_html/wpau</strong> ent&atilde;o a sua raiz de FTP &eacute; <strong>/public_html/wpau</strong><br />
		Se instalou o WOrdpress na directorio base a raiz &eacute; <strong>/</strong><br />
		</p>
	<form method="post" name="getftp" action="edit.php?page=<?php echo WPAU_PAGE; ?>&task=prelimopts&<?= $extra ?>">
<?php
		if(function_exists('wp_nonce_field')) {
			wp_nonce_field('wordpress_automatic_upgrade');
		}
?>
		<table class="editform" width="500" cellspacing="2" cellpadding="5" align="left">
			<tr>
				<td colspan="2"><strong>Acesso FTP</strong></td>
			</tr>
			<tr>
				<td><label for="disclosurepolicy-title">FTP Utilizador</label></td>
				<td><input type="text" id="wpau-ftpuser" name="wpau-ftpuser" value="" style="width: 95%" /></td>
			</tr>
			<tr>
				<td><label for="disclosurepolicy-title">FTP Password</label></td>
				<td><input type="password" id="wpau-ftppass" name="wpau-ftppass" value="" style="width: 95%" /></td>
			</tr>
			<tr>
				<td><label for="disclosurepolicy-title">FTP Directorio Raiz (O directorio onde est&aacute; o Wordpress)</label></td>
				<td><input type="text" id="wpau-ftpbasedir" name="wpau-ftpbasedir" value="" style="width: 95%" /></td>
			</tr>
			<tr>
				<td><label for="disclosurepolicy-title">FTP Host</label></td>
				<td><input type="text" id="wpau-ftphost" name="wpau-ftphost" value="" style="width: 95%" /></td>
			</tr>
			<tr>
				<td colspan="2"><input type="submit" name="wpau-submit" id="wpau-submit" value="Let's Go" /></td>
			</tr>
			</table>
		</form>
<?php
		}
		else if($allClear) {
			$link = 'edit.php?page='.WPAU_PAGE.'&task=files';
			if(function_exists('wp_nonce_url') ) {
				 $link = wp_nonce_url($link, 'wordpress_automatic_upgrade');
			}
			echo 'Todos os testes foram concluidos. <a href="'.$link.'">Clique aqui</a> para iniciar a actualiza&ccedil;&atilde;o.';
?>
			<div id="wpau-file-download"></div>
			<div id="wpau-db-download"></div>
			<div id="wpau-update-db"></div>
			Tamb&eacute;m pode escolher a <a href="#" id="wpau-automated">vers&atilde;o autom&aacute;tica</a>.<div id="wpau-status-bar"><div id="wpau-status-bar-indicator"></div></div><div id="wpau-status-message"></div></div>
<?
		}
?>
<?php
		wpauEndHtml();
		unset($prelimCheck);
	}

	/** gets the information entered by the user and sanitizes the server files so that we can run the
	WPAU plugin without any errors **/
	function wpau_prelim_opts_and_sanatize() {
		global $wbAbsPath, $isNix;

		$options = get_settings('wpau-params');
		if ( $_POST['wpau-submit'] ) {
			$wpau_ftp['ftpuser'] = strip_tags(stripslashes($_POST['wpau-ftpuser']));
			$wpau_ftp['ftppass'] = strip_tags(stripslashes($_POST['wpau-ftppass']));
			$wpau_ftp['ftphost'] = strip_tags(stripslashes($_POST['wpau-ftphost']));
			$wpau_ftp['ftpbasedir'] = strip_tags(stripslashes($_POST['wpau-ftpbasedir']));
			//only saves it temporarily so that we can run post upgrade steps
			if ( $options != $wpau_ftp ) {
				$options = $wpau_ftp;
				update_option('wpau-params', $options);
			}
		}

		require_once('wpau_prelimcheck.class.php');
		$prelimCheck = new wpauPrelimHelper(ABSPATH, $isNix);
		$prelimCheck->ftpUser = $wpau_ftp['ftpuser'];
		$prelimCheck->ftpPass = $wpau_ftp['ftppass'];
		$prelimCheck->ftpHost = $wpau_ftp['ftphost'];
		$prelimCheck->ftpBaseDir = $wpau_ftp['ftpbasedir'];
		$prelimCheck->checkFtpMode();
		if($prelimCheck->checkFTPCredentials()) {
			$makeBackUpDir = $_REQUEST['mbd'];
			if($prelimCheck->runFTPOperation()) {
				if('true' == $makeBackUpDir) {
					if(! $prelimCheck->makeBackupDir()) {
						wpauStartHtml();
						echo '<strong>Oops n&atilde;o &eacute; possivel actualizar a sua vers&atilde;o do Wordpress. Estamos a trabalhar para suportar o seu sistema em outras verses.</strong>';
						wpauEndHtml();
						return false;
					}
				}
				wpauStartHtml();
				$link = 'edit.php?page='.WPAU_PAGE.'&task=files';
				if(function_exists('wp_nonce_url') ) {
					 $link = wp_nonce_url($link, 'wordpress_automatic_upgrade');
				}
				echo 'Est&aacute; tudo ok. <a href="'.$link.'">Clique aqui</a> para come&ccedil;ar a actualiza&ccedil;&atilde;o.';
?>
		<div id="wpau-file-download"></div>
		<div id="wpau-db-download"></div>
		<div id="wpau-update-db"></div>
		Tamb&eacute;m pode escolher a  <a href="#" id="wpau-automated">vers&atilde;o autom&aacute;tica</a>.<div id="wpau-status-bar"><div id="wpau-status-bar-indicator"></div></div><div id="wpau-status-message"></div></div>
<?php
				wpauEndHtml();
			}
		}
		else {
			wpauStartHtml();
			echo '<p style="color:red;font-weight:bold">Oops!!!!! N&atilde;o foi possivel ligar ao seu servidor FTP</p>';
?>
		<ol>
			<li>Dados acesso ao seu FTP</li>
		</ol>
<p><strong>Nota:</strong> N&atilde;o s&atilde;o armazenados os daos que insere, s&oacute; s&atilde;o pedidos estes dados para ser possivel a actualiza&ccedil;&atilde;o dos ficheiros do Wordpress.</p>
		<p>Qual &eacute; a raiz do seu FTP.
		Se instalou o Wordpress em  <strong>public_html</strong> ent&atilde;o a raiz &eacute; <strong>/public_html</strong><br />
		Se o Wordpress est&aacute; instalado em <strong>public_html/wpau</strong> ent&atilde;o a sua raiz de FTP &eacute; <strong>/public_html/wpau</strong><br />
		Se instalou o WOrdpress na directorio base a raiz &eacute; <strong>/</strong><br />
		</p>
<form method="post" name="getftp" action="edit.php?page=<?php echo WPAU_PAGE; ?>&task=prelimopts">
<?php
		if(function_exists('wp_nonce_field')) {
			wp_nonce_field('wordpress_automatic_upgrade');
		}
?>
	<table class="editform" width="500" cellspacing="2" cellpadding="5" align="left">
		<tr>
			<td colspan="2"><strong>Dados acesso ao FTP</strong></td>
		</tr>
		<tr>
			<td><label for="disclosurepolicy-title">FTP Utilizador</label></td>
			<td><input type="text" id="wpau-ftpuser" name="wpau-ftpuser" value="" style="width: 95%" /></td>
		</tr>
		<tr>
			<td><label for="disclosurepolicy-title">FTP Password</label></td>
			<td><input type="password" id="wpau-ftppass" name="wpau-ftppass" value="" style="width: 95%" /></td>
		</tr>
		<tr>
			<td><label for="disclosurepolicy-title">FTP Directorio raiz (Directorio onde est&aacute; instalado o Wordpress)</label></td>
			<td><input type="text" id="wpau-ftpbasedir" name="wpau-ftpbasedir" value="" style="width: 95%" /></td>
		</tr>
		<tr>
			<td><label for="disclosurepolicy-title">FTP Host</label></td>
			<td><input type="text" id="wpau-ftphost" name="wpau-ftphost" value="" style="width: 95%" /></td>
		</tr>
		<tr>
			<td colspan="2"><input type="submit" name="wpau-submit" id="wpau-submit" value="Let's Go" /></td>
		</tr>
		</table>
	</form>
<?php
			wpauEndHtml();
		}
	}

	/**
	* FUnction to back up the existing wordpress installation files
	**/
	function wpau_backup_files($automated = false) {
		if(!current_user_can('edit_files')) {
				echo 'Oops n&atilde;o est&aacute; autorizado a fazer isso';
				return false;
		}
		global $wpauDirPath, $wpAbsPath, $theFuncComplete, $isNix, $wpIncludeDirs;
		$wpauHelper = new wpauHelper;
		$dirName = trailingslashit(ABSPATH);
		$dirName = $dirName . WPAU_BACKUP_DIR;
		$dirName = trailingslashit($dirName);
		if(! is_dir($dirName)) {
			mkdir ($dirName);
			chmod($dirName, 0757);
			$wpauHelper->createIndexes();
		}
		else {
			$wpauHelper->createIndexes();
			@chmod($dirName, 0757);
		}

		wpauPersistNoLog(false, false, $automated);
		$message = '';
		require_once('wpau_zip.class.php');
		$extension = '.zip';
		$zipFuncs = new wpauZipFuncs($wpAbsPath, $isNix, WPAU_FILES_ZIP, WPAU_BACKUP_DIR, $wpIncludeDirs, $extension);
		$zipFuncs->createArchive();
		if($zipFuncs->isFileWritten) {
			$message = '<br />Os ficheiros foram copiados. <a href="'.get_bloginfo('siteurl').'/'.WPAU_BACKUP_DIR.'/'.$_SESSION['filesbakname'].'">DOWNLOAD</a> Antes de continuar. <br/>Continue apenas depois de verificar a integridade da c&oacute;pia<br />';
			$theFuncComplete = true;
		}
		else {
			$message = 'N&atilde;o foi possivel copiar os ficheiros. n&atilde;o &eacute; possivel continuar';
			$theFuncComplete = false;
		}
		wpauPersist(true, $zipFuncs->loggedData, $theFuncComplete, $message, true);
		unset($zipFuncs);
		unset($wpauHelper);
		if($automated) { return $theFuncComplete; }
	}

	/**
	Shows the database backup options
	Taken from the plugin Wordpress Database backup created byAustin Matzko.
	**/
	function wpau_backup_db_options() {
		if(!current_user_can('edit_files')) {
				echo 'Oops n&atilde;o pode continuar';
				return false;
		}
		global $wpAbsPath, $isNix, $theFuncComplete;
		wpauPersistNoLog(false, false, $automated);
		$backupDir = WPAU_BACKUP_DIR;
		require_once('wpau_db_backup.class.php');
		$wpauDbBackup = new wpauBackup($backupDir);
		$wpauDbBackup->backup_menu();
		$message = '<br />Tabelas seleccionadas, por favor continue a c&oacute;pia<br />';
		$theFuncComplete = true;
		wpauPersist(true, $wpauDbBackup->loggedData, $theFuncComplete, $message, false);
		unset($wpauDbBackup);
	}

	/**
	Backs up the database tables and saves it to a file
	Taken from the plugin Wordpress Database backup created byAustin Matzko.
	**/
	function wpau_backup_db($automated = false) {
		if( ! current_user_can('manage_options')) {
			echo 'Oops n&atilde;o tem permiss&atilde;o para isso';
			return false;
		}
		global $wpAbsPath, $isNix, $theFuncComplete;
		wpauPersistNoLog(false, false, $automated);
		$backupDir = WPAU_BACKUP_DIR;
		$wpauHelper = new wpauHelper;
		$backupFile = WPAU_DB_ZIP . $wpauHelper->random(). '.zip';
		$_SESSION['dbbakname'] = $backupFile;
		unset($wpauHelper);
		require_once('wpau_db_backup.class.php');
		$wpauDbBackup = new wpauBackup($backupDir);
		if($wpauDbBackup->perform_backup($automated)) {
			if($wpauDbBackup->zip_backup($backupFile)) {
				$theFuncComplete = true;
				$message = 'Base de dados copiada com sucesso. <a href="'.get_bloginfo('siteurl').'/'.WPAU_BACKUP_DIR.'/'.$_SESSION['dbbakname'].'">DOWNLOAD</a> Antes de continuar. <br/>Continue apenas ap&oacute;s verificar a integridade da c&oacute;pia<br />';
			}
			else {
				$theFuncComplete = false;
				$message = 'N&atilde;o foi possivel copiar a base de dados, n&atilde;o &eacute; possivel continuar';
			}
		}
		else {
			$theFuncComplete = false;
			$message = 'N&atilde;o foi possivel copiar a base de dados, n&atilde;o &eacute; possivel continuar';
		}
		wpauPersist(true, $wpauDbBackup->loggedData, $theFuncComplete, $message, true);
		unset($wpauDbBackup);
		if($automated) { return $theFuncComplete; }
	}

/**
	* Function to show user an option whether to download files from wordpress site
	* or allow them to upload a file from their local machine
	**/
	function wpau_show_new_version_forms() {
		global $theFuncComplete;
		$theFuncComplete = true;

		wpauPersistNoLog(false, false, false);
	?>
		<script type="text/javascript" language="JavaScript">
			function showUpload(layerName) {
				document.getElementById(layerName).style.visibility = 'visible';
				document.getElementById(layerName).style.display = 'inline';
			}

			function hideUpload(layerName) {
				document.getElementById(layerName).style.visibility = 'hidden';
				document.getElementById(layerName).style.display = 'none';
			}
		</script>
		<div style="padding:left:20px;margin-left:30px;"><br /><br />
			<span><strong>Envie ou descarregue a ultima vers&atilde;o do Wordpress</strong></span>
			<p>As copias j&aacute; est&atilde;o feitas. Se ainda n&atilde;o fez download das c&oacute;pias &eacute; aconselhavel que fa&ccedil;a.</p>
			<p>Para continuar a actualiza&ccedil;&atilde;o pode escolher uma das duas formas
			<ol>
				<li>Pode fazer download do ultima vers&atilde;o do wordpress em <br />http://wordpress-pt.com/actualizacao.zip</li>
				<li>Ou enviar manualmente o ficheiro .</li>
			</ol>
			</p>
			<p>Por favor use o formulario a seguir para seleccionar a sua op&ccedil;&atilde;o</p>
			<p>NOTA: ESTE PROCESSO DEMORA ENTRE 10 E 300 SEGUNDOS, POR FAVOR N&atilde;O ACTUALIZA A P&aacute;GINA.</p>
			<p>
			<form name="wpaunewversion" method="post" enctype="multipart/form-data" action="edit.php?page=<?php echo WPAU_PAGE ?>&task=getlatestfiles">
<?php
		if(function_exists('wp_nonce_field')) {
			wp_nonce_field('wordpress_automatic_upgrade');
		}
?>
				<input type="Radio" name="subtask" value="wp-latest-ver" checked="checked" onchange="hideUpload('fileupload');" /> <strong>Descarregue a ultima versao de wordpress-pt.com</strong> (recomendado)<br />
				<input type="Radio" name="subtask" value="wp-upped-ver" onchange="showUpload('fileupload');"  disabled="true" />Ou envie o ficheiro da actualiza&ccedil;&atilde;o (n&atilde;o disponivel nesta vers&atilde;o)<br /><br />
				<div id="fileupload" style="visibility:hidden;display:none;">
				<input type="File" name="thefile" accept="application/x-zip-compressed" /> Escolha o ficheiro com a actualiza&ccedil;&atilde;o<br /><br />
				</div>
				<input type="Submit" name="doversiondownload" value="vamos a isso" />
			</form>
			</p>
		</div>
	<?php
		$loggedData = '';
		//$message = 'Select the option to start the files download';
		wpauPersist(true, $loggedData, $theFuncComplete, $message, false);
	}

	/**
	* Function to download the latest version from wordpress.org
	**/
	function wpau_get_latest_version($automated = false) {
		if( ! current_user_can('edit_files')) {
			echo 'Oops sorry you are not authorized to do this';
			return false;
		}
		global $wpAbsPath, $isNix, $theFuncComplete;
		wpauPersistNoLog(false, false, $automated);
		require_once('wpau_upgrade.class.php');
		$upgradeHelper = new wpauUpgradeHelper($wpAbsPath, $isNix, WPAU_BACKUP_DIR, ABSPATH);
		$subtask = 'wp-latest-ver';
		if( isset($_REQUEST['subtask']) ) {
			$subtask = $_REQUEST['subtask'];
		}
		if(strcasecmp($subtask, 'wp-upped-ver')) {
			if (ini_get('allow_url_fopen') == '1') {
				$downloadURL = 'http://wordpress-pt.com/actualizacao.zip';
				if($upgradeHelper->getFilesFromWP($downloadURL)) {
					$upgradeHelper->recursive_chmod_directory(ABSPATH . WPAU_BACKUP_DIR);
					$theFuncComplete = true;
					$message = 'Descarga completa de '.$downloadURL.'<br />';
				}
				else {
					$theFuncComplete = false;
					$message = 'N&atilde;o foi possivel descomprimir o ficheiro '.$downloadURL.'<br />';
				}
			}
			else {
				$url = 'www.wordpress-pt.com';
				$filename = 'actualizacao.zip';
				if($upgradeHelper->downloadFilesFromWP($url, $filename)) {
					$upgradeHelper->recursive_chmod_directory(ABSPATH . WPAU_BACKUP_DIR);
					$theFuncComplete = true;
					$message = 'Descarregado com sucesso e descompactado '.$downloadURL.'<br />';
				}
				else {
					$theFuncComplete = false;
					$message = 'N&atilde;o foi possivel descompactar o ficheiro '.$downloadURL.'<br />';
				}
			}
		}
		else {
			//read and upload the user file
			if($upgradeHelper->getUploadedFilesFromUser($_FILES)) {
				$theFuncComplete = true;
				$message = 'Successfully uploaded and unzipped all files <br />';
			}
			else {
				$theFuncComplete = false;
				$message = 'Could not upload and unzip all files <br />';
			}
		}
		wpauPersist(true, $upgradeHelper->loggedData, $theFuncComplete, $message, true);
		unset($upgradeHelper);
		if($automated) { return $theFuncComplete; }
	}

	/**
	* Function to show site downtime
	**/
	function wpau_site_down($automated = false) {
		if(!current_user_can('edit_files')) {
				echo 'Oops sorry you are not authorized to do this';
				return false;
		}
		global $wpauFileDirPath, $wpAbsPath, $isNix, $theFuncComplete;
		wpauPersistNoLog(false, false, $automated);
		require_once('wpau_upgrade.class.php');
		$upgradeHelper = new wpauUpgradeHelper($wpAbsPath, $isNix, WPAU_BACKUP_DIR, ABSPATH);
		if($upgradeHelper->doMaintenanceMode($wpauFileDirPath, 'temp-index.php')) {
			$theFuncComplete = true;
			$message = 'O site foi colocado em manuten&ccedil;&atilde;o, <a href="'.get_bloginfo('wpurl').'" target="_blank">clique aqui</a> (abre noutra janela) para confirmar';
		}
		else {
			$theFuncComplete = false;
			$message = 'N&atilde;o foi possivel colocar o site em manuten&ccedil;&atilde;o.';
		}
		wpauPersist(true, $upgradeHelper->loggedData, $theFuncComplete, $message, true);
		unset($upgradeHelper);
		if($automated) { return $theFuncComplete; }
	}

	/**
	* Function to de-activate all plugins
	**/
	function wpau_deactivate_plugins($automated = false) {
		if(!current_user_can('edit_plugins')) {
				echo 'Oops sorry you are not authorized to do this';
				return false;
		}
		global $theFuncComplete;
		wpauPersistNoLog(false, false, $automated);
		$thePlugs = array();
		require_once('wpau_plugin.class.php');
		$path = "../";
		if ($automated) { $path = "../../"; }
		$currentPlugs = get_option('active_plugins');
		foreach($currentPlugs as $plugin) {

			if ( wpau_validate_file($path.$plugin) ) {
				//another wp guys check
				if (in_array($plugin, $currentPlugs)) {
					array_push($thePlugs, $plugin);
				}
			}
		}
		$wpauPluginsHandler = new wpauPluginHandler($thePlugs);
		if($wpauPluginsHandler->deActivatePlugins()) {
			$theFuncComplete = true;
			$message = 'Todos os plugins foram desactivados excepto <strong>Wordpress Actualiza&ccedil;&atilde;o Autom&aacute;tica</strong>.';
		}
		else {
			$theFuncComplete = false;
			$message = 'N&atilde;o foi possivel desactivar os plugins por favor desactive-os manualmente. N&atilde;o desactive o plugin <strong>Wordpress Actualiza&ccedil;&atilde;o Autom&aacute;tica</strong>';
		}
		wpauPersist(true, $wpauPluginsHandler->loggedData, $theFuncComplete, $message, true);
		unset($wpauPluginsHandler);
		if($automated) { return $theFuncComplete; }
	}

	/**
	* Function to upgrade the latest files and run the upgrade.php
	**/
	function wpau_upgrade_installation($automated = false) {
		if(!current_user_can('edit_files')) {
				echo 'Oops sorry you are not authorized to do this';
				return false;
		}
		global $wpAbsPath, $isNix, $theFuncComplete;
		wpauPersistNoLog(false, false, $automated);
		require_once('wpau_upgrade.class.php');
		$upgradeHelper = new wpauUpgradeHelper($wpAbsPath, $isNix, WPAU_BACKUP_DIR, ABSPATH);
		if($upgradeHelper->upgradeFiles()) {
			$theFuncComplete = true;
			$message = 'Parab&eacute;ns a actualiza&ccedil;&atilde;o foi concluida. Por favor <a href="'.get_bloginfo('siteurl').'/wp-admin/upgrade.php" target="_blank">CLIQUE AQUI PARA PROCEDER COM O ULTIMO PASSO</a> (Abre em nova janela, ser&aacute; mostrado o link para actualizar a base de dados) e volte a esta p&aacute;gina para reactivar os plugins';
		}
		else {
			$theFuncComplete = false;
			$message = 'Oops!! N&atilde;o foi possivel actualizar os ficheiros. Foi reposto as c&oacute;pias anteriores. Clique aqui para voltar a tentar';
		}

		wpauPersist(true, $upgradeHelper->loggedData, $theFuncComplete, $message, true);
		unset($upgradeHelper);
		if($automated) { return $theFuncComplete; }
	}

	function wpau_update_database($automated = false) {
		if(!current_user_can('edit_files')) {
				echo 'Oops sorry you are not authorized to do this';
				return false;
		}
		global $wpAbsPath, $isNix, $theFuncComplete;
		wpauPersistNoLog(false, false, $automated);
		require_once('wpau_upgrade.class.php');
		$upgradeHelper = new wpauUpgradeHelper($wpAbsPath, $isNix, WPAU_BACKUP_DIR, ABSPATH);
		if($upgradeHelper->updateDatabase()) {
			$theFuncComplete = true;
			$message = 'Base de dados actualizada com sucesso!';
		}
		else {
			$theFuncComplete = false;
			$message = 'N&atilde;o foi possivel actualizar a base de dados. <a href="'.get_bloginfo('siteurl').'/wp-admin/upgrade.php" target="_blank">clique aqui</a> para actualizar manuelamente antes de reactivar os plugins';
		}
		wpauPersist(true, $upgradeHelper->loggedData, $theFuncComplete, $message, true);
		unset($upgradeHelper);
		if($automated) { return $theFuncComplete; }
	}

	/**
	* Function to activate the plugins
	**/
	function wpau_reactivate_plugins($automated = false) {
		if(!current_user_can('edit_plugins')) {
				echo 'Oops sorry you are not authorized to do this';
				return false;
		}
		global $theFuncComplete, $wpdb;
		wpauPersistNoLog(false, false, $automated);
		require_once('wpau_plugin.class.php');
		$thePlugs = array();
		$wpauPluginsHandler = new wpauPluginHandler($thePlugs);
		if($wpauPluginsHandler->reActivatePlugins($automated)) {
			$plugins = $wpdb->get_results("select plugin_name from ".WPAU_PLUGIN_TABLE." where fatal_plugin = 1");
			if(count($plugins) > 0)  {
				foreach($plugins as $plugin) {
					$message .= '<span style="color:red">O Plugin <strong>'.$plugin->plugin_name.'</strong> n&atilde;o foi activado. ter&aacute; que o activar manualmente.</span><br>';
				}
			}
			else {
				$message = 'Os plugins foram activados com sucesso!';
			}
			$theFuncComplete = true;
		}
		else {
			$theFuncComplete = true;
			$message = 'N&atilde;o foi possivel activar o plugin. por favor actualize manualmente';
		}
		$wpau_ftp = get_settings('wpau-params');
		if($wpau_ftp['ftpuser'] != '') {
			do_ftp_sanitize_operations($wpau_ftp);
		}
		$wpau_ftp['ftpuser'] = '';
		$wpau_ftp['ftppass'] = '';
		$wpau_ftp['ftphost'] = '';
		$wpau_ftp['ftpbasedir'] = '';
		//remove the ftp information from the db
		update_option('wpau-params', $wpau_ftp);

		wpauPersist(true, $wpauPluginsHandler->loggedData, $theFuncComplete, $message, true);
		unset($wpauPluginsHandler);
		if($automated) { return $theFuncComplete; }
	}

	function do_ftp_sanitize_operations($wpau_ftp, $automated = false) {
		require_once('wpau_prelimcheck.class.php');
		$prelimCheck = new wpauPrelimHelper(ABSPATH, $isNix, true);
		$prelimCheck->ftpUser = $wpau_ftp['ftpuser'];
		$prelimCheck->ftpPass = $wpau_ftp['ftppass'];
		$prelimCheck->ftpHost = $wpau_ftp['ftphost'];
		$prelimCheck->ftpBaseDir = $wpau_ftp['ftpbasedir'];
		$prelimCheck->checkFtpMode();
		if($prelimCheck->checkFTPCredentials()) {
			$prelimCheck->runFTPOperation();
		}
		unset($prelimCheck);
	}

	/** cleans up all the upgradation files**/
	function wpau_cleanup($automated = false) {
		if(!current_user_can('edit_files')) {
				echo 'Oops sorry you are not authorized to do this';
				return false;
		}
		global $wpAbsPath, $isNix, $theFuncComplete;
		$loggedData =  '<strong>Parab&eacute;ns a actualiza&ccedil;&atilde;o foi concluida!!</strong>';
		require_once('wpau_upgrade.class.php');
		$upgradeHelper = new wpauUpgradeHelper($wpAbsPath, $isNix, WPAU_BACKUP_DIR, ABSPATH);
		$upgradeHelper->cleanUpProcess();
		$returnHome = $_REQUEST['returnhome'];
		if($returnHome) {
			unset($upgradeHelper);
			//the wp_redirect does not work on some sites
			//as we already included header above while loading the plugin use plain old js
			//wp_redirect('edit.php?page='.WPAU_PAGE);
?>
		<script language="JavaScript" type="text/javascript">
			window.location = "<?php echo 'edit.php?page='.WPAU_PAGE;?>";
		</script>
<?
		}

		$loggedData .= '<p>Foram apagados os ficheiros temporarios</p>';
		$message = '<p>Foram apagados os ficheiros temporarios</p>';
		wpauStartHtml();
		$theFuncComplete = true;
		echo '<strong>'.$message.'</strong>';
		echo "<hr /><strong>ESTADO DAS TAREFAS</strong><br /><hr />";
		echo $loggedData.'<br /><br />';
		unset($upgradeHelper);
		wpauEndHtml();
		if($automated) { return $theFuncComplete; }
	}

	/**
	* Function to show the log for the upgrade
	**/
	function wpau_show_backup_log($automated = false) {
		global $wpdb;
		$logData = '';
		wpauStartHtml();
		echo '<strong>Parabens!!! O seu Wordpress foi actualizado.</strong>';
		echo '<br /><strong>Por favor descarregue as c&oacute;pias, se ainda n&atilde;o descarregou.</strong><br />';
		echo '<a href="'.get_bloginfo('siteurl').'/'.WPAU_BACKUP_DIR.'/'.$_SESSION['filesbakname'].'">DOWNLOAD COPIA FICHEIROS</a><br />';
		echo '<a href="'.get_bloginfo('siteurl').'/'.WPAU_BACKUP_DIR.'/'.$_SESSION['dbbakname'].'">DOWNLOAD COPIA BASE DE DADOS</a><br />';
		echo 'N&atilde;o esque&ccedil;a de <a href="'.get_bloginfo('siteurl').'/wp-admin/upgrade.php" target="_blank">Actualizar a base de dados</a> se ainda n&atilde;o o fez.';
		echo 'pode <a href="edit.php?page='.WPAU_PAGE.'&task=cleanup">limpar</a> os ficheiros da actualiza&ccedil;&atilde;o';
		echo "<hr /><strong>A seuir o log da actualiza&ccedil;&atilde;o</strong><br /><hr />";
		$logData = getDBLog();
		$wpauHelper = new wpauHelper;
		$dirName = trailingslashit(ABSPATH);
		$dirName = trailingslashit($dirName);
		if($wpauHelper->writeLogToDisk($dirName, WPAU_LOG_FILE, $logData)) {
			echo '<strong>Clique <a href="'.get_bloginfo('siteurl').'/'.WPAU_LOG_FILE.'" target="_blank">aqui</a> para descarregar o ficheiro de log</strong><br>';
		}
		unset($wpauHelper);
		echo $logData;
		wpauEndHtml();
	}

	/**
	* Function to show the log on failure
	**/
	function wpau_show_log($automated = false) {
		global $wpdb;
		$logData = '';
		wpauStartHtml();
		echo '<strong>Ocorreu um problema que n&atilde;o permite que a actualiza&ccedil;&atilde;o continue. Pode <a href="mailto:jantoniofcampos@sapo.pt">enviar-me</a> os logs para tentar identificar o problema.</strong>';
		echo "<hr /><strong>A seguir o log da instala&ccedil;&atilde;o</strong><br /><hr />";
		echo getDBLog();
		wpauEndHtml();
	}

	function getDBLog() {
		global $wpdb;
		$logData = '';
		$logged = $wpdb->get_results('SELECT task_name, task_status, task_description, task_log, start_date, end_date from  '.WPAU_LOG_TABLE);
		if(count($logged) > 0) {
			foreach($logged as $log) {
				$taskStatus = $log->task_status;
				if($taskStatus) { $taskStatus = 'Complete'; }
				else { $taskStatus = '<span style="color:red">Failed</span>'; }
				$logData .= '<strong>Tarefa Nome:</strong>  '. $log->task_name.'<br>';
				$logData .= '<strong>Tarefa Descri&ccedil;&atilde;o:</strong> '. $log->task_description.'<br>';
				$logData .= '<strong>Tarefa Estado:</strong> '. $taskStatus.'<br>';
				$logData .= '<strong>Tarefa Data Inicio:</strong> '. $log->start_date.'<br>';
				$logData .= '<strong>Tarefa Data de Fim:</strong> '. $log->end_date.'<br>';
				$logData .= '<strong>Tarefa Log:</strong> '. $log->task_log.'<br><br>';
			}
		}
		return $logData;
	}

	/** show start instructions **/
	function show_upgrade_start() {
	?>
		<div style="padding:left:20px;margin-left:30px;"><br /><br />
			<span><strong>A iniciar a Actualiza&ccedil;&atilde;o autom&aacute;tica do Wordpress. <a href="edit.php?page=<?php echo WPAU_PAGE ?>&task=prelim">clique para iniciar</a>. O que vamos fazer &eacute;</strong></span>
			<ol>
				<li>Testar se tem permisses a nivel de ficheiros para a fazer. <br />Se n&atilde;o tiver permisses pode fazer a actualiza&ccedil;&atilde;o via FTP.<br />Este Plugin n&atilde;o corre em Safe-Mode.</li>
				<li>Copiar e disponibilizr para download os ficheiros actuais</li>
				<li>Copiar e disponibilizr para download a base de dados actual</li>
				<li>Pode obter a actualiza&ccedil;&atilde;o de uma das seguintes formas
					<ul>
						<li>Download autom&aacute;tico de wordpress-pt.com</li>
						<li>Ou enviar a ultima vers&atilde;o (n&atilde;o disponivel nesta vers&atilde;o)</li>
					</ul>
				</li>
				<li>Desactivar os plugins e guardar lista dos plugins que estavam activos</li>
				<li>Colocar o seu site em estado de manuten&ccedil;&atilde;o</li>
				<li>Actualizar os ficheiros</li>
				<li>Reactivar os plugins</li>
				<li>Colocar o site outra vez disponivel</li>
				<li>Fornecer um log da actualiza&ccedil;&atilde;o</li>
			</ol>
			<span><strong><a href="edit.php?page=<?php echo WPAU_PAGE ?>&task=files">Clique para come&ccedil;ar</a></strong></span>
			<div>
			<div id="wpau-file-download"></div>
			<div id="wpau-db-download"></div>
			<div id="wpau-update-db"></div>
			Pode usar a <a href="#" id="wpau-automated">vers&atilde;o autom&aacute;tica</a>.<div id="wpau-status-bar"><div id="wpau-status-bar-indicator"></div></div><div id="wpau-status-message"></div></div>

		</div>

	<?php
	}

	function install() {
		global $wpdb;
		$result = mysql_query("DROP TABLE if exists `wpau_active_plugins_info`");
		$result = mysql_query("
			CREATE TABLE `wpau_active_plugins_info` (
			  `id` int(4) NOT NULL auto_increment,
			  `plugin_name` varchar(255) NOT NULL default '',
			  `plugin_status` varchar(255) NOT NULL default '',
				`plugin_deactive_response` smallint(2) NULL default '0',
				`plugin_reactive_response` smallint(2) NULL default '0',
				`fatal_plugin` smallint(2) NULL default '0',
			  PRIMARY KEY  (`id`)
			) TYPE=MyISAM;
		") or die(mysql_error().' on line: '.__LINE__);

		if (!$result) {
			return false;
		}

		$result = mysql_query("DROP TABLE if exists `wpau_upgrade_log`");
		$result = mysql_query("
			CREATE TABLE `wpau_upgrade_log` (
			  `id` int(4) NOT NULL auto_increment,
			  `task_name` varchar(150) NOT NULL default '',
			  `task_status` varchar(150) NOT NULL default '',
			  `task_description` varchar(150) NOT NULL default '',
			  `task_log` text,
			  `start_date` datetime NOT NULL default '0000-00-00 00:00:00',
			  `end_date` datetime default NULL,
			  PRIMARY KEY  (`id`)
			) TYPE=MyISAM;
		") or die(mysql_error().' on line: '.__LINE__);

			if (!$result) {
				return false;
			}

	}


	function wpau_validate_file($file, $allowed_files = '') {
		if ( false !== strpos($file, './'))
			return 1;

		if (':' == substr($file,1,1))
			return 2;

		if ( !empty($allowed_files) && (! in_array($file, $allowed_files)) )
			return 3;

		return 0;
	}

	/**
	* checks to see if everything is set first up so that it can be logged properly
	**/
	function wpau_init() {
		global $wpdb, $table_prefix;
		$wpdb->upgrade_log = $table_prefix.'upgrade_log';
		$wpdb->active_plugins_info = $table_prefix.'active_plugins_info';

		if (isset($_GET['activate']) && $_GET['activate'] == 'true') {
			$result = mysql_list_tables(DB_NAME);
			$tables = array();
			while ($row = mysql_fetch_row($result)) {
				$tables[] = $row[0];
			}
			if (!in_array($wpdb->upgrade_log, $tables) && !in_array($wpdb->active_plugins_info, $tables)) {
				install();
			}
		}
	}

	/**
	* Adds in the necessary JavaScript files for the automated version
	**/
	function wpau_add_scripts() {
		if (function_exists('wp_enqueue_script') && function_exists('wp_register_script')) {
			wp_register_script('jquery', get_bloginfo('wpurl') . '/wp-content/plugins/wordpress-automatic-upgrade-pt/js/jquery.js');
			wp_enqueue_script('wpau_auto_update', get_bloginfo('wpurl') . '/wp-content/plugins/wordpress-automatic-upgrade-pt/js/wp-wpau.js.php', array('jquery'), '0.1');
		} else {
			wpau_add_scripts_legacy();
		}
	}
	function wpau_add_scripts_legacy() {
		if (function_exists('wp_enqueue_script') && function_exists('wp_register_script')) { wpau_add_scripts(); return; }
		print('<script type="text/javascript" src="'.get_bloginfo('wpurl') . '/wp-content/plugins/wordpress-automatic-upgrade-pt/js/jquery.js"></script>'."\n");
		print('<script type="text/javascript" src="'.get_bloginfo('wpurl') . '/wp-content/plugins/wordpress-automatic-upgrade-pt/js/wp-wpau.js.php"></script>'."\n");
	}
	add_action('admin_print_scripts', 'wpau_add_scripts');
	add_action('admin_head', 'wpau_add_scripts_legacy');
	add_action('admin_menu', 'wpau_manage_page');

?>